/// <reference types="codemirror" />
/// <reference types="@types/codemirror/codemirror-showhint" />
import * as lsProtocol from 'vscode-languageserver-protocol';
import { TokenInfo, ITextEditorOptions, IPosition, LSPConnection, IEditorAdapter } from '..';
declare class CodeMirrorAdapter extends IEditorAdapter<CodeMirror.Editor> {
    options: ITextEditorOptions;
    editor: CodeMirror.Editor;
    connection: LSPConnection;
    private hoverMarker;
    private signatureWidget;
    private token;
    private markedDiagnostics;
    private highlightMarkers;
    private hoverCharacter;
    private _debouncedGetHover;
    constructor(connection: LSPConnection, options: ITextEditorOptions, editor: CodeMirror.Editor);
    _resetState(): void;
    handleMouseOver(): void;
    handleChange(): void;
    handleHover(response: lsProtocol.Hover): void;
    handleHighlight(items: lsProtocol.DocumentHighlight[]): void;
    handleCompletion(completions: lsProtocol.CompletionItem[]): void;
    handleDiagnostic(response: lsProtocol.PublishDiagnosticsParams): void;
    handleSignature(result: lsProtocol.SignatureHelp): void;
    _getTokenEndingAtPosition(code: string, location: IPosition, splitCharacters: string[]): TokenInfo;
    private _getFilteredCompletions;
}
export default CodeMirrorAdapter;
